unit Debug_Output;

{*******************************************************}
{                                                       }
{       Delphi Debug Library                            }
{       Debug_Output                                    }
{                                                       }
{       2001..2004 YT                                   }
{                                                       }
{*******************************************************}

(*
	vWrite/WriteLnOutputDebugString֏o͂Ƃ̂ł.
	ꂾǌ\֗.
*)

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
	Windows;

procedure AssignDebug(var F: Text);

implementation

{ copied from SysUtils.pas }

const
	fmClosed = $D7B0;

type
	PTextBuf = ^TTextBuf;
	TTextBuf = array[0..127] of Char;
	TTextRec = packed record
		Handle: Integer;
		Mode: Integer;
		BufSize: Cardinal;
		BufPos: Cardinal;
		BufEnd: Cardinal;
		BufPtr: PChar;
		OpenFunc: Pointer;
		InOutFunc: Pointer;
		FlushFunc: Pointer;
		CloseFunc: Pointer;
		UserData: array[1..32] of Byte;
		Name: array[0..259] of Char;
		Buffer: TTextBuf;
	end;

function DebugOpen(var T: TextFile): Integer;
begin
	Result := 0;
end;

function DebugInOut(var T: TextFile): Integer;
begin
	{WriteŌĂ΂}

	Result := 0
end;

function DebugFlush(var T: TextFile): Integer;
var
	Index: Integer;
begin
	{WriteLnŌĂ΂}
	{#0 ̊i[ AssignDebug ł - 1 g(CĂ͂悧)}

	for Index := TTextRec(T).BufEnd to TTextRec(T).BufPos - 1 do
		if TTextRec(T).Buffer[Index] = #13 then
		begin
			TTextRec(T).Buffer[Index] := #0;
			OutputDebugString(TTextRec(T).Buffer + TTextRec(T).BufEnd);
			TTextRec(T).BufEnd := Index + 1;
			if TTextRec(T).Buffer[Index + 1] = #10 then
				Inc(TTextRec(T).BufEnd);
		end;

	Move((TTextRec(T).Buffer + TTextRec(T).BufEnd)^, TTextRec(T).Buffer,
					TTextRec(T).BufPos - TTextRec(T).BufEnd);

	TTextRec(T).BufPos := TTextRec(T).BufPos - TTextRec(T).BufEnd;
	TTextRec(T).BufEnd := 0;

	Result := 0;
end;

function DebugClose(var T: TextFile): Integer;
begin
	if TTextRec(T).BufPos > TTextRec(T).BufEnd then
	begin
		TTextRec(T).Buffer[TTextRec(T).BufPos] := #0;
		OutputDebugString(TTextRec(T).Buffer + TTextRec(T).BufEnd);
	end;

	Result := 0;
end;

procedure AssignDebug(var F: Text);
begin
	TTextRec(F).Mode      := fmClosed;
	TTextRec(F).BufSize   := SizeOf(TTextRec(F).Buffer) - 1; {- 1 dv}
	TTextRec(F).BufPos    := 0;
	TTextRec(F).BufEnd    := 0;
	TTextRec(F).BufPtr    := TTextRec(F).Buffer;
	TTextRec(F).OpenFunc  := @DebugOpen;
	TTextRec(F).InOutFunc := @DebugInOut;
	TTextRec(F).FlushFunc := @DebugFlush;
	TTextRec(F).CloseFunc := @DebugClose;

	{#10ƂČ딚Ȃ悤}
	TTextRec(F).Buffer[High(TTextRec(F).Buffer)] := #0;
end;

initialization

	if not IsConsole {and (DebugHook <> 0)} then
		AssignDebug(Output);

end.
